// Raided from GNU Go code, vanilla.c

#ifndef GNUGO_H
#define GNUGO_H

#include <stdio.h>
#include <unistd.h>
#include <string.h>

#include <iostream>
#include <string>
using namespace std;


void error(const char *msg);
#define TELL_GNUGO(x) if (verbose) fprintf(stderr, "%s", x); \
                      if (fprintf(to_gnugo_stream, "%s", x) < 0) \
                         error ("can't write command in to_gnugo_stream"); \
                      fflush(to_gnugo_stream);
#define ASK_GNUGO(x)  if (!fgets(x, 128, from_gnugo_stream)) \
                         error("can't get response");

class gnugostream {
public:
  int pfd_a[2];
  int pfd_b[2];
  char gnugo_line[128], client_line[128];
  int length;
  int verbose;
  FILE *to_gnugo_stream, *from_gnugo_stream;
  gnugostream();
  int loop();
  char* sendcmd(const char*);
  void quit();
};

#endif
